## mingw-w64-waf-2.1.7-1.src.tar.zst

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2005-2018

"""
to make a custom waf file use the option --tools

To add a tool that does not exist in the folder compat15, pass an absolute path:
./waf-light  --tools=compat15,/comp/waf/aba.py --prelude=$'\tfrom waflib.extras import aba\n\taba.foo()'
"""

VERSION="2.1.7"
APPNAME='waf'
REVISION=''

top = '.'
out = 'build'

zip_types = ['bz2', 'gz', 'xz']

PRELUDE = ''

import os, sys, re, io, optparse, tokenize

from waflib import Errors, Utils, Options, Logs, Scripting
from waflib import Configure
Configure.autoconfig = 1

def sub_file(fname, lst):
	with open(fname, 'r') as f:
		txt = f.read()

	for (key, val) in lst:
		re_pat = re.compile(key, re.M)
		txt = re_pat.sub(val, txt)

	with open(fname, 'w') as f:
		f.write(txt)

def to_bytes(x):
	if sys.hexversion>0x300000f:
		return x.encode()
	return x

Logs.warn('------> Executing code from the top-level wscript <-----')
def init(ctx):
	if Options.options.setver: # maintainer only (ita)
		ver = Options.options.setver
		hexver = Utils.num2ver(ver)
		hexver = '0x%x'%hexver
		sub_file('wscript', (('^VERSION=(.*)', 'VERSION="%s"' % ver), ))
		sub_file('waf-light', (('^VERSION=(.*)', 'VERSION="%s"' % ver), ))

		pats = []
		pats.append(('^WAFVERSION=(.*)', 'WAFVERSION="%s"' % ver))
		pats.append(('^HEXVERSION(.*)', 'HEXVERSION=%s' % hexver))

		try:
			rev = ctx.cmd_and_log("git rev-parse HEAD").strip()
		except Errors.WafError:
			rev = ''
		else:
			pats.append(('^WAFREVISION(.*)', 'WAFREVISION="%s"' % rev))

		sub_file('waflib/Context.py', pats)

		sys.exit(0)

def check(ctx):
	Logs.warn('Nothing to do')

# this function is called before any other for parsing the command-line
def options(opt):

	# generate waf
	opt.add_option('--make-waf', action='store_true', default=True,
		help='creates the waf script', dest='waf')

	opt.add_option('--interpreter', action='store', default=None,
		help='specify the #! line on top of the waf file', dest='interpreter')

	opt.add_option('--sign', action='store_true', default=False, help='make a signed file', dest='signed')

	default_zip = 'bz2'
	if os.name == 'java':
		default_zip = 'gz'
	opt.add_option('--zip-type', action='store', default=default_zip,
		help='specify the zip type [Allowed values: %s]' % ' '.join(zip_types), dest='zip')

	opt.add_option('--make-batch', action='store_true', default=False,
		help='creates a convenience waf.bat file (done automatically on win32 systems)',
		dest='make_batch')

	opt.add_option('--yes', action='store_true', default=False,
		help=optparse.SUPPRESS_HELP,
		dest='yes')

	# those ones are not too interesting
	opt.add_option('--set-version', default='',
		help='sets the version number for waf releases (for the maintainer)', dest='setver')
	opt.add_option('--set-name', default='waf', help=optparse.SUPPRESS_HELP, dest='wafname')

	opt.add_option('--strip', action='store_true', default=True,
		help='shrinks waf (strip docstrings, saves 33kb)',
		dest='strip_comments')
	opt.add_option('--nostrip', action='store_false', help='no shrinking',
		dest='strip_comments')
	opt.add_option('--tools', action='store', help='Comma-separated 3rd party tools to add, eg: "compat,ocaml" [Default: "compat15"]',
		dest='add3rdparty', default='compat15')
	opt.add_option('--coretools', action='store', help='Comma-separated core tools to add, eg: "vala,tex" [Default: all of them]',
		dest='coretools', default='default')
	opt.add_option('--prelude', action='store', help='Code to execute before calling waf', dest='prelude', default=PRELUDE)
	opt.add_option('--namesfrom', action='store', help='Obtain the file names from a model archive', dest='namesfrom', default=None)
	opt.load('python')

def process_tokens(tokens):
	accu = []
	prev = tokenize.NEWLINE

	indent = 0
	line_buf = []

	for (type, token, start, end, line) in tokens:
		token = token.replace('\r\n', '\n')
		if type == tokenize.NEWLINE:
			if line_buf:
				accu.append(indent * '\t')
				ln = "".join(line_buf)
				if ln == 'if __name__=="__main__":': break
				#ln = ln.replace('\n', '')
				accu.append(ln)
				accu.append('\n')
				line_buf = []
				prev = tokenize.NEWLINE
		elif type == tokenize.INDENT:
			indent += 1
		elif type == tokenize.DEDENT:
			indent -= 1
		elif type == tokenize.NAME:
			if prev == tokenize.NAME or prev == tokenize.NUMBER: line_buf.append(' ')
			line_buf.append(token)
		elif type == tokenize.NUMBER:
			if prev == tokenize.NAME or prev == tokenize.NUMBER: line_buf.append(' ')
			line_buf.append(token)
		elif type == tokenize.STRING:
			if not line_buf and token.startswith('"'): pass
			else: line_buf.append(token)
		elif type == tokenize.COMMENT:
			pass
		elif type == tokenize.OP:
			line_buf.append(token)
		else:
			if token != "\n": line_buf.append(token)

		if token != '\n':
			prev = type

	body = ''.join(accu)
	return body

deco_re = re.compile('(def|class)\\s+(\\w+)\\(.*')
def process_decorators(body):
	lst = body.splitlines()
	accu = []
	all_deco = []
	buf = [] # put the decorator lines
	for line in lst:
		if line.startswith('@'):
			buf.append(line[1:])
		elif buf:
			name = deco_re.sub('\\2', line)
			if not name:
				raise IOError("decorator not followed by a function!" + line)
			for x in buf:
				all_deco.append('%s(%s)' % (x, name))
			accu.append(line)
			buf = []
		else:
			accu.append(line)
	return '\n'.join(accu+all_deco)

def sfilter(path):
	if path.endswith('.py') :
		if Options.options.strip_comments:
			if sys.version_info[0] >= 3:
				with open(path, 'rb') as f:
					tk = tokenize.tokenize(f.readline)
					next(tk) # the first one is always tokenize.ENCODING for Python 3, ignore it
					cnt = process_tokens(tk)
			else:
				with open(path, 'r') as f:
					cnt = process_tokens(tokenize.generate_tokens(f.readline))
		else:
			with open(path, 'r') as f:
				cnt = f.read()
		# WARNING: since python >= 2.5 is required, decorators are not processed anymore
		# uncomment the following to enable decorator replacement:
		#cnt = process_decorators(cnt)
		#if cnt.find('set(') > -1:
		#	cnt = 'import sys\nif sys.hexversion < 0x020400f0: from sets import Set as set\n' + cnt
		cnt = '#! /usr/bin/env python\n# encoding: utf-8\n# WARNING! Do not edit! https://waf.io/book/index.html#_obtaining_the_waf_file\n\n' + cnt

	else:
		with open(path, 'r') as f:
			cnt = f.read()

	if sys.hexversion > 0x030000f0:
		return (io.BytesIO(cnt.encode('utf-8')), len(cnt.encode('utf-8')), cnt)
	return (io.BytesIO(cnt), len(cnt), cnt)

def create_waf(self, *k, **kw):
	mw = 'tmp-waf-'+VERSION
	print('-> preparing %r' % mw)

	import tarfile, zipfile

	zipType = Options.options.zip.strip().lower()
	if zipType not in zip_types:
		zipType = zip_types[0]

	directory_files = {}
	files = []
	add3rdparty = []
	for x in Options.options.add3rdparty.split(','):
		if os.path.isdir(x):
			# Create mapping from files absolute path to path in module
			# directory (for module mylib):
			#
			#     {"/home/path/mylib/__init__.py": "mylib/__init__.py",
			#      "/home/path/mylib/lib.py": "mylib/lib.py",
			#      "/home/path/mylib/sub/sub.py": "mylib/sub/lib.py"
			#     }
			#
			x_dir = self.generator.bld.root.find_dir(
				os.path.abspath(os.path.expanduser(x)))

			file_list = x_dir.ant_glob('**/*.py')

			for f in file_list:

				file_from = f.abspath()
				file_to = os.path.join(x_dir.name, f.path_from(x_dir))

				# If this is executed on Windows, then file_to will contain
				# '\' path separators. These should be changed to '/', otherwise
				# the added tools will not be accessible on Unix systems.
				directory_files[file_from] = file_to.replace('\\', '/')
				files.append(file_from)

		elif os.path.isabs(x):
			files.append(x)
		else:
			add3rdparty.append(x + '.py')

	coretools = []
	for x in Options.options.coretools.split(','):
		coretools.append(x + '.py')

	up_node = self.generator.bld.path
	for node in up_node.find_dir('waflib').ant_glob(incl=['*.py', 'Tools/*.py', 'extras/*.py']):
		relpath = node.path_from(up_node)
		if node.name == '__init__.py':
			files.append(relpath)
			continue
		if node.parent.name == 'Tools' and Options.options.coretools != 'default':
			if node.name not in coretools:
				continue
		if node.parent.name == 'extras':
			if node.name not in add3rdparty:
				continue
		files.append(relpath)

	if Options.options.namesfrom:
		with tarfile.open(Options.options.namesfrom) as tar:
			oldfiles = files
			files = [x.name for x in tar.getmembers()]
			if set(files) ^ set(oldfiles):
				Logs.warn('The archive model has differences:')
				Logs.warn('- Added %r', list(set(files) - set(oldfiles)))
				Logs.warn('- Removed %r', list(set(oldfiles) - set(files)))

	#open a file as tar.[extension] for writing
	tar = tarfile.open('%s.tar.%s' % (mw, zipType), "w:%s" % zipType)
	z = zipfile.ZipFile("zip/waflib.zip", "w", compression=zipfile.ZIP_DEFLATED)
	for x in files:
		try:
			tarinfo = tar.gettarinfo(x, x)
		except NotImplementedError:
			# jython 2.7.0 workaround
			tarinfo = tarfile.TarInfo(x)
		tarinfo.uid   = tarinfo.gid   = 0
		tarinfo.uname = tarinfo.gname = 'root'
		if os.environ.get('SOURCE_DATE_EPOCH'):
			tarinfo.mtime = int(os.environ.get('SOURCE_DATE_EPOCH'))
		(code, size, cnt) = sfilter(x)
		tarinfo.size = size

		if x in directory_files:
			tarinfo.name = 'waflib/extras/' + directory_files[x]
		elif os.path.isabs(x):
			tarinfo.name = 'waflib/extras/' + os.path.split(x)[1]

		print('   adding %s as %s' % (x, tarinfo.name))
		def dest(x):
			if x in directory_files:
				return os.path.join('waflib', 'extras', directory_files[x])
			elif os.path.isabs(x):
				return os.path.join('waflib', 'extras', os.path.basename(x))
			else:
				return os.path.normpath(os.path.relpath(x, "."))

		z.write(x, dest(x))
		tar.addfile(tarinfo, code)
	tar.close()
	z.close()

	with open('waf-light', 'r') as f:
		code1 = f.read()

	# tune the application name if necessary
	if Options.options.wafname != 'waf':
		Options.options.prelude = '\tfrom waflib import Context\n\tContext.WAFNAME=%r\n' % Options.options.wafname + Options.options.prelude

	# now store the revision unique number in waf
	code1 = code1.replace("if sys.hexversion<0x206000f:\n\traise ImportError('Python >= 2.6 is required to create the waf file')\n", '')
	code1 = code1.replace('\t#import waflib.extras.compat15#PRELUDE', Options.options.prelude)

	# when possible, set the git revision in the waf file
	bld = self.generator.bld
	try:
		rev = bld.cmd_and_log('git rev-parse HEAD', quiet=0).strip()
	except Errors.WafError:
		rev = ''
	else:
		reg = re.compile('^GIT(.*)', re.M)
		code1 = reg.sub('GIT="%s"' % rev, code1)

	# if the waf file is installed somewhere... but do not do that
	prefix = ''
	reg = re.compile('^INSTALL=(.*)', re.M)
	code1 = reg.sub(r'INSTALL=%r' % prefix, code1)
	#change the tarfile extension in the waf script
	reg = re.compile('bz2', re.M)
	code1 = reg.sub(zipType, code1)
	if zipType == 'gz':
		code1 = code1.replace('bunzip2', 'gzip -d')
	elif zipType == 'xz':
		code1 = code1.replace('bunzip2', 'xz -d')

	with open('%s.tar.%s' % (mw, zipType), 'rb') as f:
		cnt = f.read()

	# the REVISION value is the md5 sum of the compressed data (facilitate audits)
	REVISION = Utils.md5(cnt, usedforsecurity=False).hexdigest()
	reg = re.compile('^REVISION=(.*)', re.M)
	code1 = reg.sub(r'REVISION="%s"' % REVISION, code1)

	def find_unused(kd, ch):
		for i in range(35, 125):
			for j in range(35, 125):
				if i==j: continue
				if i == 39 or j == 39: continue
				if i == 92 or j == 92: continue
				s = chr(i) + chr(j)
				if -1 == kd.find(s.encode()):
					return (kd.replace(ch.encode(), s.encode()), s)
		raise ValueError('Could not find a proper encoding')

	# The reverse order prevents collisions
	(cnt, C3) = find_unused(cnt, '\x00')
	(cnt, C2) = find_unused(cnt, '\r')
	(cnt, C1) = find_unused(cnt, '\n')
	ccc = code1.replace("C1='x'", "C1='%s'" % C1).replace("C2='x'", "C2='%s'" % C2).replace("C3='x'", "C3='%s'" % C3)

	if getattr(Options.options, 'interpreter', None):

=== build_system_kit/makefile_dumper/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2010 (ita)

"""
Calling 'waf build' executes a normal build with Waf
Calling 'waf clean dump' will create a makefile corresponding to the build
The dependencies will be extracted too
"""

VERSION='0.0.1'
APPNAME='cc_test'

top = '.'

def options(opt):
	opt.load('compiler_c')

def configure(conf):
	conf.load('compiler_c')

def build(bld):
	bld.program(source='main.c', target='app', use='mylib', cflags=['-O2'])
	bld.stlib(source='a.c', target='mylib')

# ---------------------------------------------------------------------------

from waflib import Build, Logs
class Dumper(Build.BuildContext):
	fun = 'dump'
	cmd = 'dump'

def dump(bld):
	# call the build function as if a real build were performed
	build(bld)

	from waflib import Task
	bld.commands = []
	bld.targets = []

	# store the command executed
	old_exec = Task.Task.exec_command
	def exec_command(self, *k, **kw):
		ret = old_exec(self, *k, **kw)
		self.command_executed = k[0]
		self.path = kw['cwd'] or self.generator.bld.cwd
		return ret
	Task.Task.exec_command = exec_command

	# perform a fake build, and accumulate the makefile bits
	old_process = Task.Task.process
	def process(self):
		old_process(self)

		lst = []
		for x in self.outputs:
			lst.append(x.path_from(self.generator.bld.bldnode))
		bld.targets.extend(lst)
		lst.append(':')
		for x in self.inputs + self.dep_nodes + self.generator.bld.node_deps.get(self.uid(), []):
			lst.append(x.path_from(self.generator.bld.bldnode))
		try:
			if isinstance(self.command_executed, list):
				self.command_executed = ' '.join(self.command_executed)
		except Exception as e:
			print(e)
		else:
			bld.commands.append(' '.join(lst))
			bld.commands.append('\tcd %s && %s' % (self.path, self.command_executed))
	Task.Task.process = process

	# write the makefile after the build is complete
	def output_makefile(self):
		self.commands.insert(0, "all: %s" % " ".join(self.targets))
		node = self.bldnode.make_node('Makefile')
		node.write('\n'.join(self.commands))
		Logs.warn('Wrote %r', node)
	bld.add_post_fun(output_makefile)

=== demos/asm/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys

def configure(conf):
	conf.load('gcc gas')
	try:
		size = sys.maxint
	except AttributeError:
		size = sys.maxsize # python 3.2
	if size < 4**21:
		conf.fatal('this example is for 64-bit systems only')

def build(bld):
	# https://waf.io/apidocs/tools/asm.html
	bld.program(
		source   = 'main.c test.S',
		target   = 'asmtest',
		defines  = 'foo=12',
		asflags  = '-Os',
		includes = '.',
                linkflags = '-no-pie')

	def disp(ctx):
		node = ctx.bldnode.ant_glob('asmtest*', remove=False)[0]
		ctx.exec_command('%s' % node.abspath(), shell=False)
	bld.add_post_fun(disp)

=== demos/bisonflex/wscript ===
#!/usr/bin/env python
# encoding: utf-8

def options(opt):
	opt.load('compiler_c')

def configure(conf):
	conf.load('compiler_c flex bison')
	conf.env.LIB_CALC = ['fl']

def build(bld):
	tg = bld(
		features = 'c cprogram',
		source = 'calc.l calc.y main.c',
		target = 'calc',
		use    = 'CALC')

	# to compile in c++ mode change to:
	#    features= 'cxx cxxprogram'
	# and add:
	#    import waflib.Tools.cxx as cxx
	#    tg.mappings['.c'] = cxx.cxx_hook

	# re-use the files for other targets:
	# bld(features='c cshlib', source='calc.tab.c calc.lex.c', use='CALC', target='hmm')

=== demos/python/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Gustavo Carneiro, 2007

import sys

VERSION='0.0.1'
APPNAME='python_test'

top = '.'
out = 'build'

def options(opt):
	opt.load('python') # options for disabling pyc or pyo compilation
	opt.load('compiler_c')

def configure(conf):
	conf.load('compiler_c')
	conf.load('python')
	conf.check_python_version((2,4,2))
	conf.check_python_headers()

	conf.check_python_module('os')
	conf.check_python_module('re', condition="ver > num(2,0,4) and ver <= num(2,3,0)")
	try:
		conf.check_python_module('pygccxml')
	except conf.errors.ConfigurationError:
		print('could not find pygccxml (ignored)')

def build(bld):

	# first compile a few pyc and pyo files (set install_path=None to disable the installation,
	# by default install_path is set to ${PYTHONDIR})
	bld(features='py', source=bld.path.ant_glob('*.py'), install_from='.')

	# example for generated python files
	from waflib import Utils
	if not Utils.is_win32:
		target = bld.path.find_or_declare('abc.py')
		bld(rule='touch ${TGT}', source='wscript', target=target)
		bld(features='py', source=[target], install_from=target.parent)

	# then a c extension module
	bld(
		features = 'c cshlib pyext',
		source   = 'spammodule.c',
		target   = 'spam')

	# then a c program
	bld(
		features = 'c cprogram pyembed',
		source   = 'test.c',
		target   = 'test')

	# Install files keeping their directory structure (default: relative_trick=True)
	#
	# This will create:
	#   * lib/python2.7/site-packages/nested_scripts/foo/nested_foo.py
	bld(features='py',
		source=bld.path.ant_glob('nested_scripts/foo/*.py'),
		install_from='.')

	# Install files flatting the directory structure (relative_trick=False)
	#
	# This will create:
	#   * lib/python2.7/site-packages/nested_bar.py
	bld(features='py',
		source=bld.path.ant_glob('nested_scripts/bar/*.py'),
		relative_trick=False,
		install_from='.')

=== demos/qt5/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2016 (ita)
# Federico Pellegrin, 2019 (fedepell)

VERSION='0.0.1'
APPNAME='qt5_test'

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_cxx qt5 waf_unit_test')

def configure(conf):
	conf.load('compiler_cxx qt5 waf_unit_test')
	#conf.env.append_value('CXXFLAGS', ['-g']) # test

	if not conf.env.QT_LRELEASE:
		# While qt5 detects most Qt tools, most of them are optional
		conf.fatal('lrelease was not found')

	# These tests would run on Ubuntu but not on other platforms
	conf.check(
		define_name  = 'XYZ_QT5_TESTS',
		mandatory    = False,
		execute      = True,
		features     = 'qt5 cxx cxxprogram',
		includes     = '.',
		defines      = 'QT_WIDGETS_LIB',
		use          = 'QT5CORE QT5GUI QT5WIDGETS QT5TEST',
		msg          = 'Checking whether Qt5 tests can run',
		fragment     = '''
#include <QtTest/QtTest>
class TestQt5Test: public QObject {
        Q_OBJECT
        private:
                void testGui() {
			QWidget *widget = NULL;
			QTest::mouseClick(widget, Qt::LeftButton, Qt::NoModifier, QPoint(5,5), 0);
		}
};

QTEST_MAIN(TestQt5Test)
#include "test.moc"
''')

def build(bld):
	# According to the Qt5 documentation:
	#   Qt classes in foo.h   -> declare foo.h as a header to be processed by moc
	#			    add the resulting moc_foo.cpp to the source files
	#   Qt classes in foo.cpp -> include foo.moc at the end of foo.cpp
	#
	bld(
		features = 'qt5 cxx cxxprogram',
		use      = 'QT5CORE QT5GUI QT5SVG QT5WIDGETS',
		source   = 'main.cpp res.qrc but.ui foo.cpp',
		moc      = 'foo.h',
		target   = 'window',
		includes = '.',
		lang     = bld.path.ant_glob('linguist/*.ts'),
		langname = 'somefile', # include the .qm files from somefile.qrc
	)

	if bld.env.XYZ_QT5_TESTS:
		# Example of integration of Qt5 Unit tests using Qt5Test using waf_unit_test
		bld(
			features = 'qt5 cxx cxxprogram test',
			use      = 'QT5CORE QT5GUI QT5WIDGETS QT5TEST',
			defines  = 'QT_WIDGETS_LIB',
			source   = 'foo.cpp testqt5.cpp',
			moc      = 'foo.h',
			target   = 'footest',
			includes = '.',
			# ut_str   = './${SRC} -o test-report.xml,xunitxml', # put output to a xunit xml
		)

		bld.add_post_fun(print_test_results)	# print output of test runner to user


def print_test_results(bld):
	lst = getattr(bld, 'utest_results', [])
	if not lst:
		return
	for result in lst:
		print(result.out.decode('utf-8'))
		print(result.err.decode('utf-8'))

=== demos/vala/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Jaap Haitsma, 2008

# the following two variables are used by the target "waf dist"
VERSION = '0.0.1'
APPNAME = 'vala-gtk-example'

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_c')
	opt.load('vala')

def configure(conf):
	conf.env.VALA_MINVER = (0, 25, 0)
	conf.load('compiler_c vala')
	conf.check_cfg(package='glib-2.0', uselib_store='GLIB', atleast_version='2.10.0', mandatory=1, args='--cflags --libs')
	conf.recurse('resources')

def build(bld):
	bld.recurse('shlib multi-file stlib resources')

=== playground/clang_cl/wscript ===
#!/usr/bin/env python
# encoding: utf-8
# vim: ts=4 sw=4 noexpandtab

top = '.'
out = 'build'

def options(opt):
	opt.load('clang_cl')

def configure(cfg):
	cfg.load('clang_cl')
	cfg.env.append_value('CFLAGS','/Zi')
	cfg.env.append_value('LDFLAGS','/DEBUG')

def build(bld):
	bld.program(
		name='test',
		source=['test.c'],
		target='test',
		use='CRT_MULTITHREADED_DLL')

=== playground/codegen/wscript ===
#! /usr/bin/env python
# coding: utf-8

def options(opt):
	opt.load('compiler_c')
def configure(cnf):
	cnf.load('compiler_c')
def build(bld):
	from waflib import Build
	bld.post_mode = Build.POST_LAZY

	def create_files(tsk):
		out = tsk.generator.path.make_node('generated')
		from waflib import Utils
		for x in out.ant_glob('*.c'):
			x.delete()
		import random
		for x in range(2):
			num = random.randint(0, 2**31)
			k = out.make_node('test%d.c' % num)
			k.write('int k%d = %d;' % (num, num))
	bld(rule=create_files, source='wscript', name='codegen')

	bld.add_group()

	bld.program(features='find_them', source=['main.c'], target='app')

from waflib.TaskGen import feature, before
from waflib import Utils
@feature('find_them')
@before('process_source')
def list_the_source_files(self):
	self.source = Utils.to_list(self.source) + self.path.ant_glob('generated/*.c')

=== playground/cpp_gen/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2010 (ita)

VERSION='0.0.1'
APPNAME='cpp_gen'

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_cxx')

def configure(conf):
	conf.load('compiler_cxx')
	conf.check(header_name='stdio.h', features='cxx cxxprogram', mandatory=False)

def build(bld):
	bld.program(source='main.cpp a.cpp', target='app')

#--------

import os
from waflib import Task, TaskGen, Utils
from waflib.Tools import cxx

@TaskGen.extension('.cpp')
def more_tasks_at_once(self, node):
   task1 = self.create_task('prog1', node, [])
   task2 = self.create_compiled_task('cxx', node)

def cmpnodes(a, b):
	return cmp(a.abspath(), b.abspath())

class prog1(Task.Task):
	before = ['cxxprogram', 'cxxshlib', 'cxxstlib']

	def uid(self):
		"""
		the unique id of this task should only depend on the file inputs
		"""
		m = Utils.md5(usedforsecurity=False)
		up = m.update
		up(self.__class__.__name__.encode())
		for x in self.inputs:
			up(x.abspath().encode())
		return m.digest()

	def runnable_status(self):
		"""
		since it is called after the build has started,
		any task added must be passed through 'more_tasks'
		"""
		for x in self.run_after:
			if not x.hasrun:
				return Task.ASK_LATER

		# so this is a bit special, the goal here is to set the output nodes
		# and to create the c++ tasks before the normal processing is done
		sig = self.signature()
		for x in self.generator.bld.raw_deps.get(sig, []):
			self.outputs.append(self.generator.bld.srcnode.find_node(x))

		if not self.outputs:
			self.read_outputs_from_cache()

		if self.outputs:
			self.create_cxx_task()

		ret = Task.Task.runnable_status(self)
		return ret

	def create_cxx_task(self):
		"""
		create a task dynamically during the build
		notice the use of 'more_tasks'
		"""
		tsk = cxx.cxx_hook(self.generator, self.outputs[0])
		tsk.set_run_after(self) # the build has started, so the order must be set manually
		self.more_tasks = [tsk] # add tasks dynamically during the build
		self.generator.link_task.inputs.append(tsk.outputs[0]) # add another input for the link task
		try:
			self.generator.link_task.inputs.sort(cmp=cmpnodes) # eliminate the random order (more tasks like this)
		except:
			self.generator.link_task.inputs.sort(key=lambda x: x.abspath()) # python3
		self.generator.link_task.set_run_after(tsk) # do not forget to set the build order there too

	def run(self):
		"""
		actual execution
		this code should not be executed if the files are retrieved from the cache
		"""
		if self.inputs[0].name == 'a.cpp':
			# simulate the creation of an interface file
			out = self.inputs[0].parent.get_bld().make_node('a.ser.cpp')
			out.write('\n\n')

		# read the file system
		# remember that nodes cannot be created concurrently
		# so you might to crate a lock if several tasks want the same nodes
		inp = self.inputs[0]
		node = inp.parent.get_bld().find_node(inp.name.replace('.cpp', '.ser.cpp'))
		if node:
			self.outputs = [node]
			h_node = inp.parent.find_node(inp.name.replace('.cpp', '.ser.h'))
			if h_node:
				self.outputs.append(h_node)

		# if there are outputs, create a new c++ task
		if self.outputs:
			self.create_cxx_task()

			# access the scanner data
			self.generator.bld.raw_deps[self.signature()] = [x.path_from(self.generator.bld.srcnode) for x in self.outputs]

	def read_outputs_from_cache(self):
		"""
		set the outputs from the results found in the cache
		we assume that the files are created in the same folder as the inputs
		if it is not like this, the nodes should be restored by another system, for example
		by storing them in a separate file during run()
		"""
		env = self.env
		sig = self.signature()
		ssig = Utils.to_hex(sig)

		# first try to access the cache folder for the task
		dname = os.path.join(self.generator.bld.cache_global, ssig)
		try:
			t1 = os.stat(dname).st_mtime
		except OSError:
			return None

		try:
			lst = os.listdir(dname)
		except:
			return

		for x in lst:
			self.outputs.append(self.inputs[0].parent.find_or_declare(x))

		# not a fresh build and the cache is removed -> remember the files in the scanner data
		self.generator.bld.raw_deps[self.signature()] = [x.path_from(self.generator.bld.srcnode) for x in self.outputs]

=== playground/dynamic_build/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2010 (ita)

VERSION='0.0.1'
APPNAME='cc_test'

"""
The build groups can be processed all at once (required for the progress bar)
or sequentially in a lazy manner.

Each time one more .c file will be added during the build and compiled and linked in app

$ waf distclean configure build build
'distclean' finished successfully (0.005s)
Setting top to                           : /dynamic_build
Setting out to                           : /dynamic_build/build
Checking for 'gcc' (c compiler)          : ok
'configure' finished successfully (0.091s)

Waf: Entering directory `/dynamic_build/build'
[1/1] foo_3.c:  -> build/foo_3.c
[2/4] c: main.c -> build/main.c.1.o
[3/4] c: build/foo_3.c -> build/foo_3.c.1.o
[4/4] cprogram: build/main.c.1.o build/foo_3.c.1.o -> build/app
Waf: Leaving directory `/dynamic_build/build'
'build' finished successfully (5.169s)

Waf: Entering directory `/dynamic_build/build'
[1/1] foo_17.c:  -> build/foo_17.c
[3/5] c: build/foo_17.c -> build/foo_17.c.1.o
[5/5] cprogram: build/main.c.1.o build/foo_17.c.1.o build/foo_3.c.1.o -> build/app
Waf: Leaving directory `/dynamic_build/build'
'build' finished successfully (5.144s)
"""

top = '.'

def options(opt):
	opt.load('compiler_c')

def configure(conf):
	conf.load('compiler_c')


def build(bld):
	import random
	rnd = random.randint(0, 25)
	bld(
		rule    = "sleep 2 && (echo 'int num%d = %d;' > ${TGT})" % (rnd, rnd),
		target  = 'foo_%d.c' % rnd,
	)

	bld.add_group()

	it = bld.path.get_bld().ant_glob('*.c', remove=False, quiet=True, generator=True)
	src = ['main.c', it]
	bld(features='c cprogram', source=src, target='app')

=== playground/dynamic_build2/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2010 (ita)

VERSION='0.0.1'
APPNAME='cc_test'

"""
"""

from waflib import Utils, Build

top = '.'

def options(opt):
	opt.load('compiler_c')

def configure(conf):
	conf.load('compiler_c')

def read_files(task):
	# the real build files must be excluded, else they will get rebuilt
	for x in task.generator.bld.bldnode.ant_glob('**', excl='**/*.o app', remove=False):
		pass

def build(bld):
	bld.post_mode = Build.POST_LAZY

	bld(rule='tar xvf ${SRC[0].abspath()}', source='foo.tar')
	bld.add_group('foo')
	bld(rule=read_files, always=True, name='read_files')
	bld.add_group('bar')
	bld.program(source='aa/main.c', target='app')


	print bld.get_group('bar')

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=waf
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=2.1.7
pkgrel=1
pkgdesc="General-purpose build system modelled after Scons (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://waf.io/"
msys2_repository_url="https://gitlab.com/ita1024/waf"
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-python")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc")
options=('!emptydirs')
source=("https://waf.io/${_realname}-${pkgver}.tar.bz2"{,.asc})
validpgpkeys=('8AF22DE5A06822E3474F3C7049B4C67C05277AAA'
              '0B3972B2D9E32EAB423D2E0F22BE0C62FFBFA548'  # "Thomas Nagy <tnagy@waf.io>"
              '8C7EB2F93B0C45F5732FE5D11BAC571DCD772295') # Waf Project <noreply@waf.io>
sha256sums=('d65141aaa59c52c65c3b9fb2ae0f280c0ddec585ff9948fe22ede1d857aeee75'
            'SKIP')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  # Extract license
  head -n 30 waf-light | tail -n 25 > LICENSE
}

build() {
  cd "${srcdir}/${_realname}-${pkgver}"
  plain "Configure ..."
  ${MINGW_PREFIX}/bin/python ./waf-light configure --prefix=${MINGW_PREFIX}
  plain "Make waf ..."
  ${MINGW_PREFIX}/bin/python ./waf-light --make-waf
}

package() {
  cd "${srcdir}/${_realname}-${pkgver}"

  prelude=$(cat <<'EOF'
	import waflib.Tools.compiler_c, waflib.Tools.compiler_cxx
	waflib.Tools.compiler_c.c_compiler['win32'] = ['gcc', 'clang', 'msvc']
	waflib.Tools.compiler_cxx.cxx_compiler['win32'] = ['g++', 'clang++', 'msvc']
EOF
  )

  ${MINGW_PREFIX}/bin/python ./waf-light install -f --destdir="${pkgdir}" \
    --prelude="${prelude}" \
    --tools='compat,compat15,ocaml,go,cython,scala,erlang,cuda,gcj,boost,pep8,eclipse,unity,clang_compilation_database'

  install -Dm755 waf "${pkgdir}${MINGW_PREFIX}/bin/waf"
  install -Dm755 waf.bat "${pkgdir}${MINGW_PREFIX}/bin/waf.bat"

  # Force the generation of .waf.admin files
  cd "${srcdir}/${_realname}-${pkgver}/demos/c"
  CC_NAME=${CC} CC="${MINGW_PREFIX}/bin/${CC}.exe" \
  CXX_NAME=${CXX} CXX="${MINGW_PREFIX}/bin/${CXX}.exe" \
  "${pkgdir}${MINGW_PREFIX}/bin/waf" configure build

  # Fix weird directory placement (FS#38216, FS#38300)
  mkdir -p "${pkgdir}${MINGW_PREFIX}/lib/waf"
  mv "${pkgdir}${MINGW_PREFIX}/bin/waf3-${pkgver}-"* "${pkgdir}${MINGW_PREFIX}/lib/waf/"
  sed -s "s|INSTALL=''|INSTALL='${MINGW_PREFIX}/lib/waf'|g" -i "${pkgdir}${MINGW_PREFIX}/bin/waf"

  cd "${srcdir}/${_realname}-${pkgver}"
  install -Dm644 LICENSE "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
